<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::stack_kernel_1&lt; T, mem_manager &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1stack__kernel__1.html">stack_kernel_1</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1stack__kernel__1-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::stack_kernel_1&lt; T, mem_manager &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::stack_kernel_1&lt; T, mem_manager &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1stack__kernel__1.png" usemap="#dlib::stack_5Fkernel_5F1_3C_20T_2C_20mem_5Fmanager_20_3E_map" alt=""/>
  <map id="dlib::stack_5Fkernel_5F1_3C_20T_2C_20mem_5Fmanager_20_3E_map" name="dlib::stack_5Fkernel_5F1_3C_20T_2C_20mem_5Fmanager_20_3E_map">
<area href="classdlib_1_1enumerable.html" alt="dlib::enumerable&lt; T &gt;" shape="rect" coords="0,0,244,24"/>
<area href="classdlib_1_1remover.html" alt="dlib::remover&lt; T &gt;" shape="rect" coords="254,0,498,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structdlib_1_1stack__kernel__1_1_1node.html">node</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a08d8c9c706362ca14ace4cca23b442cd"><td class="memItemLeft" align="right" valign="top"><a id="a08d8c9c706362ca14ace4cca23b442cd"></a>
typedef T&#160;</td><td class="memItemRight" valign="bottom"><b>type</b></td></tr>
<tr class="separator:a08d8c9c706362ca14ace4cca23b442cd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae10373c80077221c6ce3db20194ccf54"><td class="memItemLeft" align="right" valign="top"><a id="ae10373c80077221c6ce3db20194ccf54"></a>
typedef mem_manager&#160;</td><td class="memItemRight" valign="bottom"><b>mem_manager_type</b></td></tr>
<tr class="separator:ae10373c80077221c6ce3db20194ccf54"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; T &gt;</a></td></tr>
<tr class="memitem:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top">typedef T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#aece453aca3947d8b1f7bf016d5f99cda">type</a></td></tr>
<tr class="separator:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1remover"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1remover')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1remover.html">dlib::remover&lt; T &gt;</a></td></tr>
<tr class="memitem:a717e9bdbd0335036d142080dbac7d66d inherit pub_types_classdlib_1_1remover"><td class="memItemLeft" align="right" valign="top">typedef T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1remover.html#a717e9bdbd0335036d142080dbac7d66d">type</a></td></tr>
<tr class="separator:a717e9bdbd0335036d142080dbac7d66d inherit pub_types_classdlib_1_1remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:af9973c1388bc5c3256764fee969ba864"><td class="memItemLeft" align="right" valign="top"><a id="af9973c1388bc5c3256764fee969ba864"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:af9973c1388bc5c3256764fee969ba864"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2067a80588ed6d533f619e24d3658287"><td class="memItemLeft" align="right" valign="top"><a id="a2067a80588ed6d533f619e24d3658287"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>push</b> (T &amp;item)</td></tr>
<tr class="separator:a2067a80588ed6d533f619e24d3658287"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2487c5060dde613973db3aec9d05d401"><td class="memItemLeft" align="right" valign="top"><a id="a2487c5060dde613973db3aec9d05d401"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>pop</b> (T &amp;item)</td></tr>
<tr class="separator:a2487c5060dde613973db3aec9d05d401"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae43f0033065709a4aef1105b826b4492"><td class="memItemLeft" align="right" valign="top"><a id="ae43f0033065709a4aef1105b826b4492"></a>
T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>current</b> ()</td></tr>
<tr class="separator:ae43f0033065709a4aef1105b826b4492"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4f14a9ab6f72aa4d98ae559192fa97e1"><td class="memItemLeft" align="right" valign="top"><a id="a4f14a9ab6f72aa4d98ae559192fa97e1"></a>
const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>current</b> () const</td></tr>
<tr class="separator:a4f14a9ab6f72aa4d98ae559192fa97e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad2c5b112365d7f193fb7162f92a24f68"><td class="memItemLeft" align="right" valign="top"><a id="ad2c5b112365d7f193fb7162f92a24f68"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>swap</b> (<a class="el" href="classdlib_1_1stack__kernel__1.html">stack_kernel_1</a> &amp;item)</td></tr>
<tr class="separator:ad2c5b112365d7f193fb7162f92a24f68"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27a61db5bac190bf3d22a19898e44464"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1stack__kernel__1.html#a27a61db5bac190bf3d22a19898e44464">remove_any</a> (T &amp;item)</td></tr>
<tr class="separator:a27a61db5bac190bf3d22a19898e44464"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8b806e27608c82dcc5f8c884e69c0bb7"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1stack__kernel__1.html#a8b806e27608c82dcc5f8c884e69c0bb7">size</a> () const</td></tr>
<tr class="separator:a8b806e27608c82dcc5f8c884e69c0bb7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3693f985499e999937b8ed94feaa3e3f"><td class="memItemLeft" align="right" valign="top"><a id="a3693f985499e999937b8ed94feaa3e3f"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>at_start</b> () const</td></tr>
<tr class="separator:a3693f985499e999937b8ed94feaa3e3f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a804e5174aa2c291150b89120f97c5797"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1stack__kernel__1.html#a804e5174aa2c291150b89120f97c5797">reset</a> () const</td></tr>
<tr class="separator:a804e5174aa2c291150b89120f97c5797"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abcfe12e83038c437e7fe8cd2647cedab"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1stack__kernel__1.html#abcfe12e83038c437e7fe8cd2647cedab">current_element_valid</a> () const</td></tr>
<tr class="separator:abcfe12e83038c437e7fe8cd2647cedab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ba22d080f92083214dea39f42bfad62"><td class="memItemLeft" align="right" valign="top">const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1stack__kernel__1.html#a2ba22d080f92083214dea39f42bfad62">element</a> () const</td></tr>
<tr class="separator:a2ba22d080f92083214dea39f42bfad62"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad040abb789da2e715e603a40a76dfdd9"><td class="memItemLeft" align="right" valign="top">T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1stack__kernel__1.html#ad040abb789da2e715e603a40a76dfdd9">element</a> ()</td></tr>
<tr class="separator:ad040abb789da2e715e603a40a76dfdd9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ade08c1ac091cae47eff3376d009d66ec"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1stack__kernel__1.html#ade08c1ac091cae47eff3376d009d66ec">move_next</a> () const</td></tr>
<tr class="separator:ade08c1ac091cae47eff3376d009d66ec"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:aa88be82d28abe9869846bd646c33069a"><td class="memItemLeft" align="right" valign="top"><a id="aa88be82d28abe9869846bd646c33069a"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>delete_elements_in_stack</b> (<a class="el" href="structdlib_1_1stack__kernel__1_1_1node.html">node</a> *&amp;top)</td></tr>
<tr class="separator:aa88be82d28abe9869846bd646c33069a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7228cc58dc9abbcbd9b3ce1fdd11069b"><td class="memItemLeft" align="right" valign="top"><a id="a7228cc58dc9abbcbd9b3ce1fdd11069b"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>stack_kernel_1</b> (<a class="el" href="classdlib_1_1stack__kernel__1.html">stack_kernel_1</a> &amp;)</td></tr>
<tr class="separator:a7228cc58dc9abbcbd9b3ce1fdd11069b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a230a9d2af22add703467f3910bec5adb"><td class="memItemLeft" align="right" valign="top"><a id="a230a9d2af22add703467f3910bec5adb"></a>
<a class="el" href="classdlib_1_1stack__kernel__1.html">stack_kernel_1</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1stack__kernel__1.html">stack_kernel_1</a> &amp;)</td></tr>
<tr class="separator:a230a9d2af22add703467f3910bec5adb"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a5b91760dd23a582fbdb42448bbae7227"><td class="memItemLeft" align="right" valign="top">mem_manager::template rebind&lt; <a class="el" href="structdlib_1_1stack__kernel__1_1_1node.html">node</a> &gt;::other&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1stack__kernel__1.html#a5b91760dd23a582fbdb42448bbae7227">pool</a></td></tr>
<tr class="separator:a5b91760dd23a582fbdb42448bbae7227"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada09083becf4e5f39c9dd07e7611baa2"><td class="memItemLeft" align="right" valign="top"><a id="ada09083becf4e5f39c9dd07e7611baa2"></a>
<a class="el" href="structdlib_1_1stack__kernel__1_1_1node.html">node</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>top</b></td></tr>
<tr class="separator:ada09083becf4e5f39c9dd07e7611baa2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2cca7ef067dc229acd38c440fdcfb96e"><td class="memItemLeft" align="right" valign="top"><a id="a2cca7ef067dc229acd38c440fdcfb96e"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>stack_size</b></td></tr>
<tr class="separator:a2cca7ef067dc229acd38c440fdcfb96e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae806455b3312cd87374c6b14e9b5a65d"><td class="memItemLeft" align="right" valign="top"><a id="ae806455b3312cd87374c6b14e9b5a65d"></a>
<a class="el" href="structdlib_1_1stack__kernel__1_1_1node.html">node</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>current_element</b></td></tr>
<tr class="separator:ae806455b3312cd87374c6b14e9b5a65d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a49364d9b4b400dae59f6a520103197d0"><td class="memItemLeft" align="right" valign="top"><a id="a49364d9b4b400dae59f6a520103197d0"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>_at_start</b></td></tr>
<tr class="separator:a49364d9b4b400dae59f6a520103197d0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; T &gt;</a></td></tr>
<tr class="memitem:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#a328c55c7c5df14e115cd502e9756e8a3">operator=</a> (const <a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;)</td></tr>
<tr class="separator:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1remover"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1remover')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1remover.html">dlib::remover&lt; T &gt;</a></td></tr>
<tr class="memitem:a58be6630e553c7f4d14dd4c4c2b4c859 inherit pro_methods_classdlib_1_1remover"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1remover.html">remover</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1remover.html#a58be6630e553c7f4d14dd4c4c2b4c859">operator=</a> (const <a class="el" href="classdlib_1_1remover.html">remover</a> &amp;)</td></tr>
<tr class="separator:a58be6630e553c7f4d14dd4c4c2b4c859 inherit pro_methods_classdlib_1_1remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="abcfe12e83038c437e7fe8cd2647cedab"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abcfe12e83038c437e7fe8cd2647cedab">&#9670;&nbsp;</a></span>current_element_valid()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1stack__kernel__1.html">dlib::stack_kernel_1</a>&lt; T, mem_manager &gt;::current_element_valid </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - #current_element_valid() == false 
    - #at_start() == true
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1d8826bb2077f454da01103773f892c6">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="ad040abb789da2e715e603a40a76dfdd9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad040abb789da2e715e603a40a76dfdd9">&#9670;&nbsp;</a></span>element() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T &amp; <a class="el" href="classdlib_1_1stack__kernel__1.html">dlib::stack_kernel_1</a>&lt; T, mem_manager &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a43a289e594edbf10a8300f5b49569524">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a2ba22d080f92083214dea39f42bfad62"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2ba22d080f92083214dea39f42bfad62">&#9670;&nbsp;</a></span>element() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const T &amp; <a class="el" href="classdlib_1_1stack__kernel__1.html">dlib::stack_kernel_1</a>&lt; T, mem_manager &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if we are currently at a valid element else
      returns false 
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#ac8b8efc630a1ee6abe6ba2a153bf0047">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="ade08c1ac091cae47eff3376d009d66ec"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ade08c1ac091cae47eff3376d009d66ec">&#9670;&nbsp;</a></span>move_next()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1stack__kernel__1.html">dlib::stack_kernel_1</a>&lt; T, mem_manager &gt;::move_next </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a non-const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1b204b94acddc602ed8750731c7550ce">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a27a61db5bac190bf3d22a19898e44464"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a27a61db5bac190bf3d22a19898e44464">&#9670;&nbsp;</a></span>remove_any()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1stack__kernel__1.html">dlib::stack_kernel_1</a>&lt; T, mem_manager &gt;::remove_any </td>
          <td>(</td>
          <td class="paramtype">T &amp;&#160;</td>
          <td class="paramname"><em>item</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - all resources associated with *this have been released.
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1remover.html#a80c7e7417e08a66ca361f646a12aaa03">dlib::remover&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a804e5174aa2c291150b89120f97c5797"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a804e5174aa2c291150b89120f97c5797">&#9670;&nbsp;</a></span>reset()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1stack__kernel__1.html">dlib::stack_kernel_1</a>&lt; T, mem_manager &gt;::reset </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if *this represents one position before the first element
      in the container (this would also make the current element invalid) 
      else returns false                
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a2904ebf4bc18e60b5669509416827a3e">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a8b806e27608c82dcc5f8c884e69c0bb7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8b806e27608c82dcc5f8c884e69c0bb7">&#9670;&nbsp;</a></span>size()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classdlib_1_1stack__kernel__1.html">dlib::stack_kernel_1</a>&lt; T, mem_manager &gt;::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - moves to the next element.  i.e. #element() will now 
      return the next element in the container 
    - the return value will be equal to #current_element_valid() 
    - #at_start() == false 

    - returns true if there is another element 
    - returns false if there are no more elements in the container
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a3181bdae2392e004881efe86bb2cd412">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a5b91760dd23a582fbdb42448bbae7227"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5b91760dd23a582fbdb42448bbae7227">&#9670;&nbsp;</a></span>pool</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T, typename mem_manager = default_memory_manager&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">mem_manager::template rebind&lt;<a class="el" href="structdlib_1_1stack__kernel__1_1_1node.html">node</a>&gt;::other <a class="el" href="classdlib_1_1stack__kernel__1.html">dlib::stack_kernel_1</a>&lt; T, mem_manager &gt;::pool</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - top points to the top of the stack
ensures
    - all memory has been freed 
    - #top = 0
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="stack__kernel__1_8h_source.html">stack_kernel_1.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
